/*
 *  (c) 2011 Steffen Bondorf, disco | Distributed Computer Systems Lab
 *                                  University of Kaiserslautern, Germany
 *         All Rights Reserved.
 *
 *  This software is work in progress and is released in the hope that it will
 *  be useful to the scientific community. It is provided "as is" without
 *  express or implied warranty, including but not limited to the correctness
 *  of the code or its suitability for any particular purpose.
 *
 *  You are free to use this software for any non-commercial educational or
 *  research purpose, provided that this copyright notice is not removed or
 *  modified. For commercial uses please contact the respective author(s).
 *
 *  If you find our software useful, we would appreciate if you mentioned it
 *  in any publication arising from the use of this software or acknowledge
 *  our work otherwise. We would also like to hear of any fixes or useful
 *  extensions to this software.
 *
 */

package unikl.disco.network;

/**
 * 
 * @author Steffen Bondorf
 *
 */
public class Edge {
	private Vertex src;
	private Vertex dest;
	
	private String alias;

	protected Edge(Vertex source, Vertex destination) {
		src = source;
		dest = destination;
	}

	public Vertex getSource() {
		return src;
	}
	
	public Vertex getDest() {
		return dest;
	}

	public String getAlias() {
		return alias;
	}
	
	public void setAlias( String name ) {
		alias = name;
	}

	public boolean equals( Edge e ){
		if( e == null || e.getClass() != this.getClass() ) {
			return false;
		}

		return (this.src != null? this.src.equals(e.src) : e.src == null)
				&& (this.dest != null? this.dest.equals(e.dest) : e.dest == null);
	}

	@Override
	public int hashCode() {
		int hash = 7;
		hash = 83 * hash + (this.src != null ? this.src.hashCode() : 0);
		hash = 83 * hash + (this.dest != null ? this.dest.hashCode() : 0);
		return hash;
	}

	@Override
	public String toString() {
		return "(" + String.valueOf(src) + ", " + String.valueOf(dest) + ")";
	}
}
